// This file is part of www.nand2tetris.org
// and the book "The Elements of Computing Systems"
// by Nisan and Schocken, MIT Press.
// File name: projects/04/Fill.asm

// Runs an infinite loop that listens to the keyboard input.
// When a key is pressed (any key), the program blackens the screen,
// i.e. writes "black" in every pixel;
// the screen should remain fully black as long as the key is pressed. 
// When no key is pressed, the program clears the screen, i.e. writes
// "white" in every pixel;
// the screen should remain fully clear as long as no key is pressed.

// Put your code here.

//initialise R0 to point at start of screen
(START)
@SCREEN
D=A
@R0
M=D

//check if a key is pressed
(CHECK)
//@KBD
//D=M

//if not:
//jump to no key
//@NOKEY
//D;JEQ

//if so:
//blacken pixel at R0
@32767
D=A
@R0
A=M
M=D

//increment R0
@R0
M=M+1

//check if R0 != 24576 (end of screen)
@24576
D=A
@R0
D=D-M

//if so:
//jump back to check
@CHECK
D;JNE

//otherwise:
//jump back to start (reset R)
@START
0;JMP

(NOKEY)
//check if R0 == SCREEN
@SCREEN
D=A
@R0
D=D-M

//if so:
//jump back to check
@CHECK
D;JEQ

//otherwise:
//deincrement R0
@R0
M=M-1

//whiten pixel at R0
@0
D=A
@R0
A=M
M=D

//jump back to check
@CHECK
0;JMP